import{S as nd,i as ld,s as id,e as r,k as d,w as f,t as o,M as pd,c as n,d as a,m as u,a as l,x as m,h as s,b as c,G as t,g as p,y as _,q as g,o as v,B as b,v as cd}from"../../chunks/vendor-hf-doc-builder.js";import{T as rd}from"../../chunks/Tip-hf-doc-builder.js";import{I as Re}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as y}from"../../chunks/CodeBlock-hf-doc-builder.js";function dd(Bt){let h,N,w,A,R,k,K,M;return{c(){h=r("p"),N=o("\u{1F4A1} Read the "),w=r("a"),A=o("LLM.int8(): 8-bit Matrix Multiplication for Transformers at Scale"),R=o(" paper to learn more, or you can take a look at the corresponding "),k=r("a"),K=o("blog post"),M=o(" for a gentler introduction."),this.h()},l(D){h=n(D,"P",{});var S=l(h);N=s(S,"\u{1F4A1} Read the "),w=n(S,"A",{href:!0,rel:!0});var E=l(w);A=s(E,"LLM.int8(): 8-bit Matrix Multiplication for Transformers at Scale"),E.forEach(a),R=s(S," paper to learn more, or you can take a look at the corresponding "),k=n(S,"A",{href:!0,rel:!0});var F=l(k);K=s(F,"blog post"),F.forEach(a),M=s(S," for a gentler introduction."),S.forEach(a),this.h()},h(){c(w,"href","https://arxiv.org/abs/2208.07339"),c(w,"rel","nofollow"),c(k,"href","https://huggingface.co/blog/hf-bitsandbytes-integration"),c(k,"rel","nofollow")},m(D,S){p(D,h,S),t(h,N),t(h,w),t(w,A),t(h,R),t(h,k),t(k,K),t(h,M)},d(D){D&&a(h)}}}function ud(Bt){let h,N,w,A,R,k,K,M,D,S,E,F,ie,Me,pe,ce,Ne;return{c(){h=r("p"),N=o("\u{1F4A1} The weight matrix is scaled by "),w=r("code"),A=o("lora_alpha/r"),R=o(", and a higher "),k=r("code"),K=o("lora_alpha"),M=o(" value assigns more weight to the LoRA activations. For performance, we recommend setting bias to "),D=r("code"),S=o("None"),E=o(" first, and then "),F=r("code"),ie=o("lora_only"),Me=o(", before trying "),pe=r("code"),ce=o("all"),Ne=o(".")},l(de){h=n(de,"P",{});var $=l(h);N=s($,"\u{1F4A1} The weight matrix is scaled by "),w=n($,"CODE",{});var Gt=l(w);A=s(Gt,"lora_alpha/r"),Gt.forEach(a),R=s($,", and a higher "),k=n($,"CODE",{});var Kt=l(k);K=s(Kt,"lora_alpha"),Kt.forEach(a),M=s($," value assigns more weight to the LoRA activations. For performance, we recommend setting bias to "),D=n($,"CODE",{});var Fe=l(D);S=s(Fe,"None"),Fe.forEach(a),E=s($," first, and then "),F=n($,"CODE",{});var X=l(F);ie=s(X,"lora_only"),X.forEach(a),Me=s($,", before trying "),pe=n($,"CODE",{});var He=l(pe);ce=s(He,"all"),He.forEach(a),Ne=s($,"."),$.forEach(a)},m(de,$){p(de,h,$),t(h,N),t(h,w),t(w,A),t(h,R),t(h,k),t(k,K),t(h,M),t(h,D),t(D,S),t(h,E),t(h,F),t(F,ie),t(h,Me),t(h,pe),t(pe,ce),t(h,Ne)},d(de){de&&a(h)}}}function hd(Bt){let h,N,w,A,R,k,K,M,D,S,E,F,ie,Me,pe,ce,Ne,de,$,Gt,Kt,Fe,X,He,H,nr,We,ba,lr,ir,ya,pr,cr,Ue,dr,ur,Oo,Xt,hr,Io,Ve,Ro,ue,ye,wa,Ye,fr,ka,mr,Mo,Z,_r,$a,gr,vr,Ea,br,yr,No,Be,Fo,Zt,wr,Ho,Ge,Wo,he,we,qa,Ke,kr,ja,$r,Uo,Q,Er,Xe,qr,jr,Ze,Sr,Ar,Vo,C,Cr,Qe,Pr,Dr,Sa,Tr,Lr,Aa,zr,xr,Ca,Or,Ir,Pa,Rr,Mr,Yo,Je,Bo,fe,ke,Da,et,Nr,Ta,Fr,Go,Qt,Hr,Ko,tt,Xo,W,Wr,La,Ur,Vr,za,Yr,Br,at,Gr,Kr,Zo,ot,Qo,T,Xr,xa,Zr,Qr,st,Jr,en,Oa,tn,an,Ia,on,sn,Jo,rt,es,Jt,rn,ts,J,nt,nn,Ra,ln,pn,cn,lt,dn,Ma,un,hn,fn,it,mn,Na,_n,gn,as,pt,os,q,vn,Fa,bn,yn,ct,wn,kn,Ha,$n,En,Wa,qn,jn,Ua,Sn,An,Va,Cn,Pn,ss,dt,rs,ee,Dn,Ya,Tn,Ln,Ba,zn,xn,ns,ut,ls,me,$e,Ga,ht,On,Ka,In,is,j,Rn,ea,Xa,Mn,Nn,ft,Fn,Hn,Za,Wn,Un,Qa,Vn,Yn,Ja,Bn,Gn,eo,Kn,Xn,ps,mt,cs,Ee,Zn,to,Qn,Jn,ds,_t,us,te,el,ao,tl,al,gt,oo,ol,sl,hs,U,_e,rl,so,nl,ll,ro,il,pl,cl,no,dl,ul,lo,hl,fl,vt,ml,io,_l,gl,fs,bt,ms,qe,vl,ta,bl,yl,_s,L,aa,po,wl,kl,$l,oa,co,El,ql,jl,ae,uo,Sl,Al,ho,Cl,Pl,fo,Dl,Tl,Ll,sa,mo,zl,xl,Ol,yt,_o,Il,Rl,go,Ml,gs,je,vs,wt,bs,V,Nl,ra,Fl,Hl,vo,Wl,Ul,na,Vl,Yl,ys,kt,ws,z,Bl,$t,Gl,Kl,la,Xl,Zl,bo,Ql,Jl,yo,ei,ti,ks,Et,$s,Se,ai,qt,oi,si,Es,jt,qs,x,ri,wo,ni,li,St,ii,pi,ko,ci,di,At,ui,hi,js,Ct,Ss,ge,Ae,$o,Pt,fi,Eo,mi,As,Dt,Tt,_i,gi,Cs,Lt,Ps,Y,vi,zt,qo,bi,yi,jo,wi,ki,So,$i,Ei,Ds,xt,Ts,ve,Ce,Ao,Ot,qi,Co,ji,Ls,Pe,Si,It,Ai,Ci,zs,Rt,xs,be,De,Po,Mt,Pi,Do,Di,Os,ia,Ti,Is,P,Li,pa,zi,xi,ca,Oi,Ii,To,Ri,Mi,Lo,Ni,Fi,zo,Hi,Wi,Rs,Nt,Ms,oe,Ui,Ft,Vi,Yi,Ht,Bi,Gi,Ns,Wt,Fs,da,Ki,Hs,Ut,Ws;return k=new Re({}),X=new rd({props:{$$slots:{default:[dd]},$$scope:{ctx:Bt}}}),Ve=new y({props:{code:"!pip install -q peft transformers datasets accelerate evaluate jiwer bitsandbytes",highlighted:"!pip install -q peft transformers datasets accelerate evaluate jiwer bitsandbytes"}}),Ye=new Re({}),Be=new y({props:{code:`import os

os.environ["CUDA_VISIBLE_DEVICES"] = "0"
model_name_or_path = "openai/whisper-large-v2"
language = "Marathi"
language_abbr = "mr"
task = "transcribe"
dataset_name = "mozilla-foundation/common_voice_11_0"`,highlighted:`<span class="hljs-keyword">import</span> os

os.environ[<span class="hljs-string">&quot;CUDA_VISIBLE_DEVICES&quot;</span>] = <span class="hljs-string">&quot;0&quot;</span>
model_name_or_path = <span class="hljs-string">&quot;openai/whisper-large-v2&quot;</span>
language = <span class="hljs-string">&quot;Marathi&quot;</span>
language_abbr = <span class="hljs-string">&quot;mr&quot;</span>
task = <span class="hljs-string">&quot;transcribe&quot;</span>
dataset_name = <span class="hljs-string">&quot;mozilla-foundation/common_voice_11_0&quot;</span>`}}),Ge=new y({props:{code:`from huggingface_hub import notebook_login

notebook_login()`,highlighted:`<span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> notebook_login

notebook_login()`}}),Ke=new Re({}),Je=new y({props:{code:`from datasets import load_dataset
from datasets import load_dataset, DatasetDict

common_voice = DatasetDict()

common_voice["train"] = load_dataset(dataset_name, language_abbr, split="train+validation", use_auth_token=True)
common_voice["test"] = load_dataset(dataset_name, language_abbr, split="test", use_auth_token=True)
common_voice["train"][0]`,highlighted:`<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset, DatasetDict

common_voice = DatasetDict()

common_voice[<span class="hljs-string">&quot;train&quot;</span>] = load_dataset(dataset_name, language_abbr, split=<span class="hljs-string">&quot;train+validation&quot;</span>, use_auth_token=<span class="hljs-literal">True</span>)
common_voice[<span class="hljs-string">&quot;test&quot;</span>] = load_dataset(dataset_name, language_abbr, split=<span class="hljs-string">&quot;test&quot;</span>, use_auth_token=<span class="hljs-literal">True</span>)
common_voice[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]`}}),et=new Re({}),tt=new y({props:{code:`from transformers import AutoFeatureExtractor, AutoTokenizer, AutoProcessor

feature_extractor = AutoFeatureExtractor.from_pretrained(model_name_or_path)
tokenizer = AutoTokenizer.from_pretrained(model_name_or_path, language=language, task=task)
processor = AutoProcessor.from_pretrained(model_name_or_path, language=language, task=task)`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor, AutoTokenizer, AutoProcessor

feature_extractor = AutoFeatureExtractor.from_pretrained(model_name_or_path)
tokenizer = AutoTokenizer.from_pretrained(model_name_or_path, language=language, task=task)
processor = AutoProcessor.from_pretrained(model_name_or_path, language=language, task=task)`}}),ot=new y({props:{code:`common_voice = common_voice.remove_columns(
    ["accent", "age", "client_id", "down_votes", "gender", "locale", "path", "segment", "up_votes"]
)
common_voice["train"][0]
{
    "audio": {
        "path": "/root/.cache/huggingface/datasets/downloads/extracted/f7e1ef6a2d14f20194999aad5040c5d4bb3ead1377de3e1bbc6e9dba34d18a8a/common_voice_mr_30585613.mp3",
        "array": array(
            [1.13686838e-13, -1.42108547e-13, -1.98951966e-13, ..., 4.83472422e-06, 3.54798703e-06, 1.63231743e-06]
        ),
        "sampling_rate": 48000,
    },
    "sentence": "\u0906\u0908\u091A\u0947 \u0906\u091C\u093E\u0930\u092A\u0923 \u0935\u093E\u0922\u0924 \u091A\u093E\u0932\u0932\u0947, \u0924\u0938\u0924\u0936\u0940 \u092E\u0925\u0940\u0939\u0940 \u0928\u0940\u091F \u0916\u093E\u0924\u092A\u0940\u0924\u0928\u093E\u0936\u0940 \u091D\u093E\u0932\u0940.",
}`,highlighted:`common_voice = common_voice.remove_columns(
    [<span class="hljs-string">&quot;accent&quot;</span>, <span class="hljs-string">&quot;age&quot;</span>, <span class="hljs-string">&quot;client_id&quot;</span>, <span class="hljs-string">&quot;down_votes&quot;</span>, <span class="hljs-string">&quot;gender&quot;</span>, <span class="hljs-string">&quot;locale&quot;</span>, <span class="hljs-string">&quot;path&quot;</span>, <span class="hljs-string">&quot;segment&quot;</span>, <span class="hljs-string">&quot;up_votes&quot;</span>]
)
common_voice[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{
    <span class="hljs-string">&quot;audio&quot;</span>: {
        <span class="hljs-string">&quot;path&quot;</span>: <span class="hljs-string">&quot;/root/.cache/huggingface/datasets/downloads/extracted/f7e1ef6a2d14f20194999aad5040c5d4bb3ead1377de3e1bbc6e9dba34d18a8a/common_voice_mr_30585613.mp3&quot;</span>,
        <span class="hljs-string">&quot;array&quot;</span>: array(
            [<span class="hljs-number">1.13686838e-13</span>, -<span class="hljs-number">1.42108547e-13</span>, -<span class="hljs-number">1.98951966e-13</span>, ..., <span class="hljs-number">4.83472422e-06</span>, <span class="hljs-number">3.54798703e-06</span>, <span class="hljs-number">1.63231743e-06</span>]
        ),
        <span class="hljs-string">&quot;sampling_rate&quot;</span>: <span class="hljs-number">48000</span>,
    },
    <span class="hljs-string">&quot;sentence&quot;</span>: <span class="hljs-string">&quot;\u0906\u0908\u091A\u0947 \u0906\u091C\u093E\u0930\u092A\u0923 \u0935\u093E\u0922\u0924 \u091A\u093E\u0932\u0932\u0947, \u0924\u0938\u0924\u0936\u0940 \u092E\u0925\u0940\u0939\u0940 \u0928\u0940\u091F \u0916\u093E\u0924\u092A\u0940\u0924\u0928\u093E\u0936\u0940 \u091D\u093E\u0932\u0940.&quot;</span>,
}`}}),rt=new y({props:{code:`from datasets import Audio

common_voice = common_voice.cast_column("audio", Audio(sampling_rate=16000))
common_voice["train"][0]
{
    "audio": {
        "path": "/root/.cache/huggingface/datasets/downloads/extracted/f7e1ef6a2d14f20194999aad5040c5d4bb3ead1377de3e1bbc6e9dba34d18a8a/common_voice_mr_30585613.mp3",
        "array": array(
            [-3.06954462e-12, -3.63797881e-12, -4.54747351e-12, ..., -7.74800901e-06, -1.74738125e-06, 4.36312439e-06]
        ),
        "sampling_rate": 16000,
    },
    "sentence": "\u0906\u0908\u091A\u0947 \u0906\u091C\u093E\u0930\u092A\u0923 \u0935\u093E\u0922\u0924 \u091A\u093E\u0932\u0932\u0947, \u0924\u0938\u0924\u0936\u0940 \u092E\u0925\u0940\u0939\u0940 \u0928\u0940\u091F \u0916\u093E\u0924\u092A\u0940\u0924\u0928\u093E\u0936\u0940 \u091D\u093E\u0932\u0940.",
}`,highlighted:`<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Audio

common_voice = common_voice.cast_column(<span class="hljs-string">&quot;audio&quot;</span>, Audio(sampling_rate=<span class="hljs-number">16000</span>))
common_voice[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{
    <span class="hljs-string">&quot;audio&quot;</span>: {
        <span class="hljs-string">&quot;path&quot;</span>: <span class="hljs-string">&quot;/root/.cache/huggingface/datasets/downloads/extracted/f7e1ef6a2d14f20194999aad5040c5d4bb3ead1377de3e1bbc6e9dba34d18a8a/common_voice_mr_30585613.mp3&quot;</span>,
        <span class="hljs-string">&quot;array&quot;</span>: array(
            [-<span class="hljs-number">3.06954462e-12</span>, -<span class="hljs-number">3.63797881e-12</span>, -<span class="hljs-number">4.54747351e-12</span>, ..., -<span class="hljs-number">7.74800901e-06</span>, -<span class="hljs-number">1.74738125e-06</span>, <span class="hljs-number">4.36312439e-06</span>]
        ),
        <span class="hljs-string">&quot;sampling_rate&quot;</span>: <span class="hljs-number">16000</span>,
    },
    <span class="hljs-string">&quot;sentence&quot;</span>: <span class="hljs-string">&quot;\u0906\u0908\u091A\u0947 \u0906\u091C\u093E\u0930\u092A\u0923 \u0935\u093E\u0922\u0924 \u091A\u093E\u0932\u0932\u0947, \u0924\u0938\u0924\u0936\u0940 \u092E\u0925\u0940\u0939\u0940 \u0928\u0940\u091F \u0916\u093E\u0924\u092A\u0940\u0924\u0928\u093E\u0936\u0940 \u091D\u093E\u0932\u0940.&quot;</span>,
}`}}),pt=new y({props:{code:`def prepare_dataset(batch):
    audio = batch["audio"]
    batch["input_features"] = feature_extractor(audio["array"], sampling_rate=audio["sampling_rate"]).input_features[0]
    batch["labels"] = tokenizer(batch["sentence"]).input_ids
    return batch`,highlighted:`<span class="hljs-keyword">def</span> <span class="hljs-title function_">prepare_dataset</span>(<span class="hljs-params">batch</span>):
    audio = batch[<span class="hljs-string">&quot;audio&quot;</span>]
    batch[<span class="hljs-string">&quot;input_features&quot;</span>] = feature_extractor(audio[<span class="hljs-string">&quot;array&quot;</span>], sampling_rate=audio[<span class="hljs-string">&quot;sampling_rate&quot;</span>]).input_features[<span class="hljs-number">0</span>]
    batch[<span class="hljs-string">&quot;labels&quot;</span>] = tokenizer(batch[<span class="hljs-string">&quot;sentence&quot;</span>]).input_ids
    <span class="hljs-keyword">return</span> batch`}}),dt=new y({props:{code:'common_voice = common_voice.map(prepare_dataset, remove_columns=common_voice.column_names["train"], num_proc=2)',highlighted:'common_voice = common_voice.<span class="hljs-built_in">map</span>(prepare_dataset, remove_columns=common_voice.column_names[<span class="hljs-string">&quot;train&quot;</span>], num_proc=<span class="hljs-number">2</span>)'}}),ut=new y({props:{code:`import torch

from dataclasses import dataclass
from typing import Any, Dict, List, Union


@dataclass
class DataCollatorSpeechSeq2SeqWithPadding:
    processor: Any

    def __call__(self, features: List[Dict[str, Union[List[int], torch.Tensor]]]) -> Dict[str, torch.Tensor]:
        input_features = [{"input_features": feature["input_features"]} for feature in features]
        batch = self.processor.feature_extractor.pad(input_features, return_tensors="pt")

        label_features = [{"input_ids": feature["labels"]} for feature in features]
        labels_batch = self.processor.tokenizer.pad(label_features, return_tensors="pt")

        labels = labels_batch["input_ids"].masked_fill(labels_batch.attention_mask.ne(1), -100)

        if (labels[:, 0] == self.processor.tokenizer.bos_token_id).all().cpu().item():
            labels = labels[:, 1:]

        batch["labels"] = labels

        return batch


data_collator = DataCollatorSpeechSeq2SeqWithPadding(processor=processor)`,highlighted:`<span class="hljs-keyword">import</span> torch

<span class="hljs-keyword">from</span> dataclasses <span class="hljs-keyword">import</span> dataclass
<span class="hljs-keyword">from</span> typing <span class="hljs-keyword">import</span> <span class="hljs-type">Any</span>, <span class="hljs-type">Dict</span>, <span class="hljs-type">List</span>, <span class="hljs-type">Union</span>


<span class="hljs-meta">@dataclass</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">DataCollatorSpeechSeq2SeqWithPadding</span>:
    processor: <span class="hljs-type">Any</span>

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__call__</span>(<span class="hljs-params">self, features: <span class="hljs-type">List</span>[<span class="hljs-type">Dict</span>[<span class="hljs-built_in">str</span>, <span class="hljs-type">Union</span>[<span class="hljs-type">List</span>[<span class="hljs-built_in">int</span>], torch.Tensor]]]</span>) -&gt; <span class="hljs-type">Dict</span>[<span class="hljs-built_in">str</span>, torch.Tensor]:
        input_features = [{<span class="hljs-string">&quot;input_features&quot;</span>: feature[<span class="hljs-string">&quot;input_features&quot;</span>]} <span class="hljs-keyword">for</span> feature <span class="hljs-keyword">in</span> features]
        batch = self.processor.feature_extractor.pad(input_features, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

        label_features = [{<span class="hljs-string">&quot;input_ids&quot;</span>: feature[<span class="hljs-string">&quot;labels&quot;</span>]} <span class="hljs-keyword">for</span> feature <span class="hljs-keyword">in</span> features]
        labels_batch = self.processor.tokenizer.pad(label_features, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

        labels = labels_batch[<span class="hljs-string">&quot;input_ids&quot;</span>].masked_fill(labels_batch.attention_mask.ne(<span class="hljs-number">1</span>), -<span class="hljs-number">100</span>)

        <span class="hljs-keyword">if</span> (labels[:, <span class="hljs-number">0</span>] == self.processor.tokenizer.bos_token_id).<span class="hljs-built_in">all</span>().cpu().item():
            labels = labels[:, <span class="hljs-number">1</span>:]

        batch[<span class="hljs-string">&quot;labels&quot;</span>] = labels

        <span class="hljs-keyword">return</span> batch


data_collator = DataCollatorSpeechSeq2SeqWithPadding(processor=processor)`}}),ht=new Re({}),mt=new y({props:{code:`from transformers import AutoModelForSpeechSeq2Seq

model = AutoModelForSpeechSeq2Seq.from_pretrained(model_name_or_path, load_in_8bit=True, device_map="auto")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForSpeechSeq2Seq

model = AutoModelForSpeechSeq2Seq.from_pretrained(model_name_or_path, load_in_8bit=<span class="hljs-literal">True</span>, device_map=<span class="hljs-string">&quot;auto&quot;</span>)`}}),_t=new y({props:{code:`model.config.forced_decoder_ids = None
model.config.suppress_tokens = []`,highlighted:`model.config.forced_decoder_ids = <span class="hljs-literal">None</span>
model.config.suppress_tokens = []`}}),bt=new y({props:{code:`from peft import prepare_model_for_int8_training

model = prepare_model_for_int8_training(model, output_embedding_layer_name="proj_out")`,highlighted:`<span class="hljs-keyword">from</span> peft <span class="hljs-keyword">import</span> prepare_model_for_int8_training

model = prepare_model_for_int8_training(model, output_embedding_layer_name=<span class="hljs-string">&quot;proj_out&quot;</span>)`}}),je=new rd({props:{$$slots:{default:[ud]},$$scope:{ctx:Bt}}}),wt=new y({props:{code:`from peft import LoraConfig, PeftModel, LoraModel, LoraConfig, get_peft_model

config = LoraConfig(r=32, lora_alpha=64, target_modules=["q_proj", "v_proj"], lora_dropout=0.05, bias="None")`,highlighted:`<span class="hljs-keyword">from</span> peft <span class="hljs-keyword">import</span> LoraConfig, PeftModel, LoraModel, LoraConfig, get_peft_model

config = LoraConfig(r=<span class="hljs-number">32</span>, lora_alpha=<span class="hljs-number">64</span>, target_modules=[<span class="hljs-string">&quot;q_proj&quot;</span>, <span class="hljs-string">&quot;v_proj&quot;</span>], lora_dropout=<span class="hljs-number">0.05</span>, bias=<span class="hljs-string">&quot;None&quot;</span>)`}}),kt=new y({props:{code:`model = get_peft_model(model, config)
model.print_trainable_parameters()
"trainable params: 15728640 || all params: 1559033600 || trainable%: 1.0088711365810203"`,highlighted:`model = get_peft_model(model, config)
model.print_trainable_parameters()
<span class="hljs-string">&quot;trainable params: 15728640 || all params: 1559033600 || trainable%: 1.0088711365810203&quot;</span>`}}),Et=new y({props:{code:`from transformers import Seq2SeqTrainingArguments

training_args = Seq2SeqTrainingArguments(
    output_dir="your-name/int8-whisper-large-v2-asr",
    per_device_train_batch_size=8,
    gradient_accumulation_steps=1,
    learning_rate=1e-3,
    warmup_steps=50,
    num_train_epochs=3,
    evaluation_strategy="epoch",
    fp16=True,
    per_device_eval_batch_size=8,
    generation_max_length=128,
    logging_steps=25,
    remove_unused_columns=False,
    label_names=["labels"],
)`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Seq2SeqTrainingArguments

training_args = Seq2SeqTrainingArguments(
    output_dir=<span class="hljs-string">&quot;your-name/int8-whisper-large-v2-asr&quot;</span>,
    per_device_train_batch_size=<span class="hljs-number">8</span>,
    gradient_accumulation_steps=<span class="hljs-number">1</span>,
    learning_rate=<span class="hljs-number">1e-3</span>,
    warmup_steps=<span class="hljs-number">50</span>,
    num_train_epochs=<span class="hljs-number">3</span>,
    evaluation_strategy=<span class="hljs-string">&quot;epoch&quot;</span>,
    fp16=<span class="hljs-literal">True</span>,
    per_device_eval_batch_size=<span class="hljs-number">8</span>,
    generation_max_length=<span class="hljs-number">128</span>,
    logging_steps=<span class="hljs-number">25</span>,
    remove_unused_columns=<span class="hljs-literal">False</span>,
    label_names=[<span class="hljs-string">&quot;labels&quot;</span>],
)`}}),jt=new y({props:{code:`from transformers.trainer_utils import PREFIX_CHECKPOINT_DIR


class SavePeftModelCallback(TrainerCallback):
    def on_save(
        self,
        args: TrainingArguments,
        state: TrainerState,
        control: TrainerControl,
        **kwargs,
    ):
        checkpoint_folder = os.path.join(args.output_dir, f"{PREFIX_CHECKPOINT_DIR}-{state.global_step}")

        peft_model_path = os.path.join(checkpoint_folder, "adapter_model")
        kwargs["model"].save_pretrained(peft_model_path)

        pytorch_model_path = os.path.join(checkpoint_folder, "pytorch_model.bin")
        if os.path.exists(pytorch_model_path):
            os.remove(pytorch_model_path)
        return control`,highlighted:`<span class="hljs-keyword">from</span> transformers.trainer_utils <span class="hljs-keyword">import</span> PREFIX_CHECKPOINT_DIR


<span class="hljs-keyword">class</span> <span class="hljs-title class_">SavePeftModelCallback</span>(<span class="hljs-title class_ inherited__">TrainerCallback</span>):
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">on_save</span>(<span class="hljs-params">
        self,
        args: TrainingArguments,
        state: TrainerState,
        control: TrainerControl,
        **kwargs,
    </span>):
        checkpoint_folder = os.path.join(args.output_dir, <span class="hljs-string">f&quot;<span class="hljs-subst">{PREFIX_CHECKPOINT_DIR}</span>-<span class="hljs-subst">{state.global_step}</span>&quot;</span>)

        peft_model_path = os.path.join(checkpoint_folder, <span class="hljs-string">&quot;adapter_model&quot;</span>)
        kwargs[<span class="hljs-string">&quot;model&quot;</span>].save_pretrained(peft_model_path)

        pytorch_model_path = os.path.join(checkpoint_folder, <span class="hljs-string">&quot;pytorch_model.bin&quot;</span>)
        <span class="hljs-keyword">if</span> os.path.exists(pytorch_model_path):
            os.remove(pytorch_model_path)
        <span class="hljs-keyword">return</span> control`}}),Ct=new y({props:{code:`from transformers import Seq2SeqTrainer, TrainerCallback, Seq2SeqTrainingArguments, TrainerState, TrainerControl

trainer = Seq2SeqTrainer(
    args=training_args,
    model=model,
    train_dataset=common_voice["train"],
    eval_dataset=common_voice["test"],
    data_collator=data_collator,
    tokenizer=processor.feature_extractor,
    callbacks=[SavePeftModelCallback],
)
model.config.use_cache = False
trainer.train()`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Seq2SeqTrainer, TrainerCallback, Seq2SeqTrainingArguments, TrainerState, TrainerControl

trainer = Seq2SeqTrainer(
    args=training_args,
    model=model,
    train_dataset=common_voice[<span class="hljs-string">&quot;train&quot;</span>],
    eval_dataset=common_voice[<span class="hljs-string">&quot;test&quot;</span>],
    data_collator=data_collator,
    tokenizer=processor.feature_extractor,
    callbacks=[SavePeftModelCallback],
)
model.config.use_cache = <span class="hljs-literal">False</span>
trainer.train()`}}),Pt=new Re({}),Lt=new y({props:{code:`import evaluate

metric = evaluate.load("wer")`,highlighted:`<span class="hljs-keyword">import</span> evaluate

metric = evaluate.load(<span class="hljs-string">&quot;wer&quot;</span>)`}}),xt=new y({props:{code:`from torch.utils.data import DataLoader
from tqdm import tqdm
import numpy as np
import gc

eval_dataloader = DataLoader(common_voice["test"], batch_size=8, collate_fn=data_collator)

model.eval()
for step, batch in enumerate(tqdm(eval_dataloader)):
    with torch.cuda.amp.autocast():
        with torch.no_grad():
            generated_tokens = (
                model.generate(
                    input_features=batch["input_features"].to("cuda"),
                    decoder_input_ids=batch["labels"][:, :4].to("cuda"),
                    max_new_tokens=255,
                )
                .cpu()
                .numpy()
            )
            labels = batch["labels"].cpu().numpy()
            labels = np.where(labels != -100, labels, tokenizer.pad_token_id)
            decoded_preds = tokenizer.batch_decode(generated_tokens, skip_special_tokens=True)
            decoded_labels = tokenizer.batch_decode(labels, skip_special_tokens=True)
            metric.add_batch(
                predictions=decoded_preds,
                references=decoded_labels,
            )
    del generated_tokens, labels, batch
    gc.collect()
wer = 100 * metric.compute()
print(f"{wer=}")`,highlighted:`<span class="hljs-keyword">from</span> torch.utils.data <span class="hljs-keyword">import</span> DataLoader
<span class="hljs-keyword">from</span> tqdm <span class="hljs-keyword">import</span> tqdm
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">import</span> gc

eval_dataloader = DataLoader(common_voice[<span class="hljs-string">&quot;test&quot;</span>], batch_size=<span class="hljs-number">8</span>, collate_fn=data_collator)

model.<span class="hljs-built_in">eval</span>()
<span class="hljs-keyword">for</span> step, batch <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(tqdm(eval_dataloader)):
    <span class="hljs-keyword">with</span> torch.cuda.amp.autocast():
        <span class="hljs-keyword">with</span> torch.no_grad():
            generated_tokens = (
                model.generate(
                    input_features=batch[<span class="hljs-string">&quot;input_features&quot;</span>].to(<span class="hljs-string">&quot;cuda&quot;</span>),
                    decoder_input_ids=batch[<span class="hljs-string">&quot;labels&quot;</span>][:, :<span class="hljs-number">4</span>].to(<span class="hljs-string">&quot;cuda&quot;</span>),
                    max_new_tokens=<span class="hljs-number">255</span>,
                )
                .cpu()
                .numpy()
            )
            labels = batch[<span class="hljs-string">&quot;labels&quot;</span>].cpu().numpy()
            labels = np.where(labels != -<span class="hljs-number">100</span>, labels, tokenizer.pad_token_id)
            decoded_preds = tokenizer.batch_decode(generated_tokens, skip_special_tokens=<span class="hljs-literal">True</span>)
            decoded_labels = tokenizer.batch_decode(labels, skip_special_tokens=<span class="hljs-literal">True</span>)
            metric.add_batch(
                predictions=decoded_preds,
                references=decoded_labels,
            )
    <span class="hljs-keyword">del</span> generated_tokens, labels, batch
    gc.collect()
wer = <span class="hljs-number">100</span> * metric.compute()
<span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;<span class="hljs-subst">{wer=}</span>&quot;</span>)`}}),Ot=new Re({}),Rt=new y({props:{code:'model.push_to_hub("your-name/int8-whisper-large-v2-asr")',highlighted:'model.push_to_hub(<span class="hljs-string">&quot;your-name/int8-whisper-large-v2-asr&quot;</span>)'}}),Mt=new Re({}),Nt=new y({props:{code:`from peft import PeftModel, PeftConfig

peft_model_id = "smangrul/openai-whisper-large-v2-LORA-colab"
language = "Marathi"
task = "transcribe"
peft_config = PeftConfig.from_pretrained(peft_model_id)
model = WhisperForConditionalGeneration.from_pretrained(
    peft_config.base_model_name_or_path, load_in_8bit=True, device_map="auto"
)
model = PeftModel.from_pretrained(model, peft_model_id)
tokenizer = WhisperTokenizer.from_pretrained(peft_config.base_model_name_or_path, language=language, task=task)
processor = WhisperProcessor.from_pretrained(peft_config.base_model_name_or_path, language=language, task=task)
feature_extractor = processor.feature_extractor
forced_decoder_ids = processor.get_decoder_prompt_ids(language=language, task=task)`,highlighted:`<span class="hljs-keyword">from</span> peft <span class="hljs-keyword">import</span> PeftModel, PeftConfig

peft_model_id = <span class="hljs-string">&quot;smangrul/openai-whisper-large-v2-LORA-colab&quot;</span>
language = <span class="hljs-string">&quot;Marathi&quot;</span>
task = <span class="hljs-string">&quot;transcribe&quot;</span>
peft_config = PeftConfig.from_pretrained(peft_model_id)
model = WhisperForConditionalGeneration.from_pretrained(
    peft_config.base_model_name_or_path, load_in_8bit=<span class="hljs-literal">True</span>, device_map=<span class="hljs-string">&quot;auto&quot;</span>
)
model = PeftModel.from_pretrained(model, peft_model_id)
tokenizer = WhisperTokenizer.from_pretrained(peft_config.base_model_name_or_path, language=language, task=task)
processor = WhisperProcessor.from_pretrained(peft_config.base_model_name_or_path, language=language, task=task)
feature_extractor = processor.feature_extractor
forced_decoder_ids = processor.get_decoder_prompt_ids(language=language, task=task)`}}),Wt=new y({props:{code:`from transformers import AutomaticSpeechRecognitionPipeline

audio = "https://huggingface.co/datasets/stevhliu/dummy/resolve/main/mrt_01523_00028548203.wav"
pipeline = AutomaticSpeechRecognitionPipeline(model=model, tokenizer=tokenizer, feature_extractor=feature_extractor)`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutomaticSpeechRecognitionPipeline

audio = <span class="hljs-string">&quot;https://huggingface.co/datasets/stevhliu/dummy/resolve/main/mrt_01523_00028548203.wav&quot;</span>
pipeline = AutomaticSpeechRecognitionPipeline(model=model, tokenizer=tokenizer, feature_extractor=feature_extractor)`}}),Ut=new y({props:{code:`with torch.cuda.amp.autocast():
    text = pipe(audio, generate_kwargs={"forced_decoder_ids": forced_decoder_ids}, max_new_tokens=255)["text"]
text
"\u092E\u0940 \u0924\u0941\u092E\u091A\u094D\u092F\u093E\u0938\u093E\u0920\u0940 \u0915\u093E\u0939\u0940 \u0915\u0930\u0942 \u0936\u0915\u0924\u094B \u0915\u093E?"`,highlighted:`<span class="hljs-keyword">with</span> torch.cuda.amp.autocast():
    text = pipe(audio, generate_kwargs={<span class="hljs-string">&quot;forced_decoder_ids&quot;</span>: forced_decoder_ids}, max_new_tokens=<span class="hljs-number">255</span>)[<span class="hljs-string">&quot;text&quot;</span>]
text
<span class="hljs-string">&quot;\u092E\u0940 \u0924\u0941\u092E\u091A\u094D\u092F\u093E\u0938\u093E\u0920\u0940 \u0915\u093E\u0939\u0940 \u0915\u0930\u0942 \u0936\u0915\u0924\u094B \u0915\u093E?&quot;</span>`}}),{c(){h=r("meta"),N=d(),w=r("h1"),A=r("a"),R=r("span"),f(k.$$.fragment),K=d(),M=r("span"),D=o("int8 training for automatic speech recognition"),S=d(),E=r("p"),F=o("Quantization reduces the precision of floating point data types, decreasing the memory required to store model weights. However, quantization degrades inference performance because you lose information when you reduce the precision. 8-bit or "),ie=r("code"),Me=o("int8"),pe=o(" quantization uses only a quarter precision, but it does not degrade performance because it doesn\u2019t just drop the bits or data. Instead, "),ce=r("code"),Ne=o("int8"),de=o(" quantization "),$=r("em"),Gt=o("rounds"),Kt=o(" from one data type to another."),Fe=d(),f(X.$$.fragment),He=d(),H=r("p"),nr=o("This guide will show you how to train a "),We=r("a"),ba=r("code"),lr=o("openai/whisper-large-v2"),ir=o(" model for multilingual automatic speech recognition (ASR) using a combination of "),ya=r("code"),pr=o("int8"),cr=o(" quantization and LoRA. You\u2019ll train Whisper for multilingual ASR on Marathi from the "),Ue=r("a"),dr=o("Common Voice 11.0"),ur=o(" dataset."),Oo=d(),Xt=r("p"),hr=o("Before you start, make sure you have all the necessary libraries installed:"),Io=d(),f(Ve.$$.fragment),Ro=d(),ue=r("h2"),ye=r("a"),wa=r("span"),f(Ye.$$.fragment),fr=d(),ka=r("span"),mr=o("Setup"),Mo=d(),Z=r("p"),_r=o("Let\u2019s take care of some of the setup first so you can start training faster later. Set the "),$a=r("code"),gr=o("CUDA_VISIBLE_DEVICES"),vr=o(" to "),Ea=r("code"),br=o("0"),yr=o(" to use the first GPU on your machine. Then you can specify the model name (either a Hub model repository id or a path to a directory containing the model), language and language abbreviation to train on, the task type, and the dataset name:"),No=d(),f(Be.$$.fragment),Fo=d(),Zt=r("p"),wr=o("You can also log in to your Hugging Face account to save and share your trained model on the Hub if you\u2019d like:"),Ho=d(),f(Ge.$$.fragment),Wo=d(),he=r("h2"),we=r("a"),qa=r("span"),f(Ke.$$.fragment),kr=d(),ja=r("span"),$r=o("Load dataset and metric"),Uo=d(),Q=r("p"),Er=o("The "),Xe=r("a"),qr=o("Common Voice 11.0"),jr=o(" dataset contains many hours of recorded speech in many different languages. This guide uses the "),Ze=r("a"),Sr=o("Marathi"),Ar=o(" language as an example, but feel free to use any other language you\u2019re interested in."),Vo=d(),C=r("p"),Cr=o("Initialize a "),Qe=r("a"),Pr=o("DatasetDict"),Dr=o(" structure, and load the "),Sa=r("code"),Tr=o("train"),Lr=o(" (load both the "),Aa=r("code"),zr=o("train+validation"),xr=o(" split into "),Ca=r("code"),Or=o("train"),Ir=o(") and "),Pa=r("code"),Rr=o("test"),Mr=o(" splits from the dataset into it:"),Yo=d(),f(Je.$$.fragment),Bo=d(),fe=r("h2"),ke=r("a"),Da=r("span"),f(et.$$.fragment),Nr=d(),Ta=r("span"),Fr=o("Preprocess dataset"),Go=d(),Qt=r("p"),Hr=o("Let\u2019s prepare the dataset for training. Load a feature extractor, tokenizer, and processor. You should also pass the language and task to the tokenizer and processor so they know how to process the inputs:"),Ko=d(),f(tt.$$.fragment),Xo=d(),W=r("p"),Wr=o("You\u2019ll only be training on the "),La=r("code"),Ur=o("sentence"),Vr=o(" and "),za=r("code"),Yr=o("audio"),Br=o(" columns, so you can remove the rest of the metadata with "),at=r("a"),Gr=o("remove_columns"),Kr=o(":"),Zo=d(),f(ot.$$.fragment),Qo=d(),T=r("p"),Xr=o("If you look at the "),xa=r("code"),Zr=o("sampling_rate"),Qr=o(", you\u2019ll see the audio was sampled at 48kHz. The Whisper model was pretrained on audio inputs at 16kHZ which means you\u2019ll need to downsample the audio inputs to match what the model was pretrained on. Downsample the audio by using the "),st=r("a"),Jr=o("cast_column"),en=o(" method on the "),Oa=r("code"),tn=o("audio"),an=o(" column, and set the "),Ia=r("code"),on=o("sampling_rate"),sn=o(" to 16kHz. The audio input is resampled on the fly the next time you call it:"),Jo=d(),f(rt.$$.fragment),es=d(),Jt=r("p"),rn=o("Once you\u2019ve cleaned up the dataset, you can write a function to generate the correct model inputs. The function should:"),ts=d(),J=r("ol"),nt=r("li"),nn=o("Resample the audio inputs to 16kHZ by loading the "),Ra=r("code"),ln=o("audio"),pn=o(" column."),cn=d(),lt=r("li"),dn=o("Compute the input features from the audio "),Ma=r("code"),un=o("array"),hn=o(" using the feature extractor."),fn=d(),it=r("li"),mn=o("Tokenize the "),Na=r("code"),_n=o("sentence"),gn=o(" column to the input labels."),as=d(),f(pt.$$.fragment),os=d(),q=r("p"),vn=o("Apply the "),Fa=r("code"),bn=o("prepare_dataset"),yn=o(" function to the dataset with the "),ct=r("a"),wn=o("map"),kn=o(" function, and set the "),Ha=r("code"),$n=o("num_proc"),En=o(" argument to "),Wa=r("code"),qn=o("2"),jn=o(" to enable multiprocessing (if "),Ua=r("code"),Sn=o("map"),An=o(" hangs, then set "),Va=r("code"),Cn=o("num_proc=1"),Pn=o("):"),ss=d(),f(dt.$$.fragment),rs=d(),ee=r("p"),Dn=o("Finally, create a "),Ya=r("code"),Tn=o("DataCollator"),Ln=o(" class to pad the labels in each batch to the maximum length, and replace padding with "),Ba=r("code"),zn=o("-100"),xn=o(" so they\u2019re ignored by the loss function. Then initialize an instance of the data collator:"),ns=d(),f(ut.$$.fragment),ls=d(),me=r("h2"),$e=r("a"),Ga=r("span"),f(ht.$$.fragment),On=d(),Ka=r("span"),In=o("Train"),is=d(),j=r("p"),Rn=o("Now that the dataset is ready, you can turn your attention to the model. Start by loading the pretrained "),ea=r("a"),Xa=r("code"),Mn=o("openai/whisper-large-v2"),Nn=o(" model from "),ft=r("a"),Fn=o("AutoModelForSpeechSeq2Seq"),Hn=o(", and make sure to set the "),Za=r("code"),Wn=o("load_in_8bit"),Un=o(" argument to "),Qa=r("code"),Vn=o("True"),Yn=o(" to enable "),Ja=r("code"),Bn=o("int8"),Gn=o(" quantization. The "),eo=r("code"),Kn=o("device_map=auto"),Xn=o(" argument automatically determines how to load and store the model weights:"),ps=d(),f(mt.$$.fragment),cs=d(),Ee=r("p"),Zn=o("You should configure "),to=r("code"),Qn=o("forced_decoder_ids=None"),Jn=o(" because no tokens are used before sampling, and you won\u2019t need to suppress any tokens during generation either:"),ds=d(),f(_t.$$.fragment),us=d(),te=r("p"),el=o("To get the model ready for "),ao=r("code"),tl=o("int8"),al=o(" quantization, use the utility function "),gt=r("a"),oo=r("code"),ol=o("prepare_model_for_int8_training"),sl=o(" to handle the following:"),hs=d(),U=r("ul"),_e=r("li"),rl=o("casts the "),so=r("code"),nl=o("LayerNorm"),ll=o(" to full precision ("),ro=r("code"),il=o("fp32"),pl=o(") for stability"),cl=d(),no=r("li"),dl=o("adds a forward hook to the input embedding layer to calculate the gradients of the input hidden states"),ul=d(),lo=r("li"),hl=o("enables gradient checkpointing for more memory-efficient training"),fl=d(),vt=r("li"),ml=o("casts the output logits to "),io=r("code"),_l=o("fp32"),gl=o(" for smoother sampling"),fs=d(),f(bt.$$.fragment),ms=d(),qe=r("p"),vl=o("Let\u2019s also apply LoRA to the training to make it even more efficient. Load a "),ta=r("a"),bl=o("LoraConfig"),yl=o(" and configure the following parameters:"),_s=d(),L=r("ul"),aa=r("li"),po=r("code"),wl=o("r"),kl=o(", the dimension of the low-rank matrices"),$l=d(),oa=r("li"),co=r("code"),El=o("lora_alpha"),ql=o(", scaling factor for the weight matrices"),jl=d(),ae=r("li"),uo=r("code"),Sl=o("target_modules"),Al=o(", the name of the attention matrices to apply LoRA to ("),ho=r("code"),Cl=o("q_proj"),Pl=o(" and "),fo=r("code"),Dl=o("v_proj"),Tl=o(", or query and value in this case)"),Ll=d(),sa=r("li"),mo=r("code"),zl=o("lora_dropout"),xl=o(", dropout probability of the LoRA layers"),Ol=d(),yt=r("li"),_o=r("code"),Il=o("bias"),Rl=o(", set to "),go=r("code"),Ml=o("none"),gs=d(),f(je.$$.fragment),vs=d(),f(wt.$$.fragment),bs=d(),V=r("p"),Nl=o("After you set up the "),ra=r("a"),Fl=o("LoraConfig"),Hl=o(", wrap it and the base model with the "),vo=r("code"),Wl=o("get_peft_model()"),Ul=o(" function to create a "),na=r("a"),Vl=o("PeftModel"),Yl=o(". Print out the number of trainable parameters to see how much more efficient LoRA is compared to fully training the model!"),ys=d(),f(kt.$$.fragment),ws=d(),z=r("p"),Bl=o("Now you\u2019re ready to define some training hyperparameters in the "),$t=r("a"),Gl=o("Seq2SeqTrainingArguments"),Kl=o(" class, such as where to save the model to, batch size, learning rate, and number of epochs to train for. The "),la=r("a"),Xl=o("PeftModel"),Zl=o(" doesn\u2019t have the same signature as the base model, so you\u2019ll need to explicitly set "),bo=r("code"),Ql=o("remove_unused_columns=False"),Jl=o(" and "),yo=r("code"),ei=o('label_names=["labels"]'),ti=o("."),ks=d(),f(Et.$$.fragment),$s=d(),Se=r("p"),ai=o("It is also a good idea to write a custom "),qt=r("a"),oi=o("TrainerCallback"),si=o(" to save model checkpoints during training:"),Es=d(),f(jt.$$.fragment),qs=d(),x=r("p"),ri=o("Pass the "),wo=r("code"),ni=o("Seq2SeqTrainingArguments"),li=o(", model, datasets, data collator, tokenizer, and callback to the "),St=r("a"),ii=o("Seq2SeqTrainer"),pi=o(". You can optionally set "),ko=r("code"),ci=o("model.config.use_cache = False"),di=o(" to silence any warnings. Once everything is ready, call "),At=r("a"),ui=o("train"),hi=o(" to start training!"),js=d(),f(Ct.$$.fragment),Ss=d(),ge=r("h2"),Ae=r("a"),$o=r("span"),f(Pt.$$.fragment),fi=d(),Eo=r("span"),mi=o("Evaluate"),As=d(),Dt=r("p"),Tt=r("a"),_i=o("Word error rate"),gi=o(" (WER) is a common metric for evaluating ASR models. Load the WER metric from \u{1F917} Evaluate:"),Cs=d(),f(Lt.$$.fragment),Ps=d(),Y=r("p"),vi=o("Write a loop to evaluate the model performance. Set the model to evaluation mode first, and write the loop with "),zt=r("a"),qo=r("code"),bi=o("torch.cuda.amp.autocast()"),yi=o(" because "),jo=r("code"),wi=o("int8"),ki=o(" training requires autocasting. Then, pass a batch of examples to the model to evaluate. Get the decoded predictions and labels, and add them as a batch to the WER metric before calling "),So=r("code"),$i=o("compute"),Ei=o(" to get the final WER score:"),Ds=d(),f(xt.$$.fragment),Ts=d(),ve=r("h2"),Ce=r("a"),Ao=r("span"),f(Ot.$$.fragment),qi=d(),Co=r("span"),ji=o("Share model"),Ls=d(),Pe=r("p"),Si=o("Once you\u2019re happy with your results, you can upload your model to the Hub with the "),It=r("a"),Ai=o("push_to_hub"),Ci=o(" method:"),zs=d(),f(Rt.$$.fragment),xs=d(),be=r("h2"),De=r("a"),Po=r("span"),f(Mt.$$.fragment),Pi=d(),Do=r("span"),Di=o("Inference"),Os=d(),ia=r("p"),Ti=o("Let\u2019s test the model out now!"),Is=d(),P=r("p"),Li=o("Instantiate the model configuration from "),pa=r("a"),zi=o("PeftConfig"),xi=o(", and from here, you can use the configuration to load the base and "),ca=r("a"),Oi=o("PeftModel"),Ii=o(", tokenizer, processor, and feature extractor. Remember to define the "),To=r("code"),Ri=o("language"),Mi=o(" and "),Lo=r("code"),Ni=o("task"),Fi=o(" in the tokenizer, processor, and "),zo=r("code"),Hi=o("forced_decoder_ids"),Wi=o(":"),Rs=d(),f(Nt.$$.fragment),Ms=d(),oe=r("p"),Ui=o("Load an audio sample (you can listen to it in the "),Ft=r("a"),Vi=o("Dataset Preview"),Yi=o(") to transcribe, and the "),Ht=r("a"),Bi=o("AutomaticSpeechRecognitionPipeline"),Gi=o(":"),Ns=d(),f(Wt.$$.fragment),Fs=d(),da=r("p"),Ki=o("Then use the pipeline with autocast as a context manager on the audio sample:"),Hs=d(),f(Ut.$$.fragment),this.h()},l(e){const i=pd('[data-svelte="svelte-1phssyn"]',document.head);h=n(i,"META",{name:!0,content:!0}),i.forEach(a),N=u(e),w=n(e,"H1",{class:!0});var Vt=l(w);A=n(Vt,"A",{id:!0,class:!0,href:!0});var xo=l(A);R=n(xo,"SPAN",{});var ep=l(R);m(k.$$.fragment,ep),ep.forEach(a),xo.forEach(a),K=u(Vt),M=n(Vt,"SPAN",{});var tp=l(M);D=s(tp,"int8 training for automatic speech recognition"),tp.forEach(a),Vt.forEach(a),S=u(e),E=n(e,"P",{});var Te=l(E);F=s(Te,"Quantization reduces the precision of floating point data types, decreasing the memory required to store model weights. However, quantization degrades inference performance because you lose information when you reduce the precision. 8-bit or "),ie=n(Te,"CODE",{});var ap=l(ie);Me=s(ap,"int8"),ap.forEach(a),pe=s(Te," quantization uses only a quarter precision, but it does not degrade performance because it doesn\u2019t just drop the bits or data. Instead, "),ce=n(Te,"CODE",{});var op=l(ce);Ne=s(op,"int8"),op.forEach(a),de=s(Te," quantization "),$=n(Te,"EM",{});var sp=l($);Gt=s(sp,"rounds"),sp.forEach(a),Kt=s(Te," from one data type to another."),Te.forEach(a),Fe=u(e),m(X.$$.fragment,e),He=u(e),H=n(e,"P",{});var Le=l(H);nr=s(Le,"This guide will show you how to train a "),We=n(Le,"A",{href:!0,rel:!0});var rp=l(We);ba=n(rp,"CODE",{});var np=l(ba);lr=s(np,"openai/whisper-large-v2"),np.forEach(a),rp.forEach(a),ir=s(Le," model for multilingual automatic speech recognition (ASR) using a combination of "),ya=n(Le,"CODE",{});var lp=l(ya);pr=s(lp,"int8"),lp.forEach(a),cr=s(Le," quantization and LoRA. You\u2019ll train Whisper for multilingual ASR on Marathi from the "),Ue=n(Le,"A",{href:!0,rel:!0});var ip=l(Ue);dr=s(ip,"Common Voice 11.0"),ip.forEach(a),ur=s(Le," dataset."),Le.forEach(a),Oo=u(e),Xt=n(e,"P",{});var pp=l(Xt);hr=s(pp,"Before you start, make sure you have all the necessary libraries installed:"),pp.forEach(a),Io=u(e),m(Ve.$$.fragment,e),Ro=u(e),ue=n(e,"H2",{class:!0});var Us=l(ue);ye=n(Us,"A",{id:!0,class:!0,href:!0});var cp=l(ye);wa=n(cp,"SPAN",{});var dp=l(wa);m(Ye.$$.fragment,dp),dp.forEach(a),cp.forEach(a),fr=u(Us),ka=n(Us,"SPAN",{});var up=l(ka);mr=s(up,"Setup"),up.forEach(a),Us.forEach(a),Mo=u(e),Z=n(e,"P",{});var ua=l(Z);_r=s(ua,"Let\u2019s take care of some of the setup first so you can start training faster later. Set the "),$a=n(ua,"CODE",{});var hp=l($a);gr=s(hp,"CUDA_VISIBLE_DEVICES"),hp.forEach(a),vr=s(ua," to "),Ea=n(ua,"CODE",{});var fp=l(Ea);br=s(fp,"0"),fp.forEach(a),yr=s(ua," to use the first GPU on your machine. Then you can specify the model name (either a Hub model repository id or a path to a directory containing the model), language and language abbreviation to train on, the task type, and the dataset name:"),ua.forEach(a),No=u(e),m(Be.$$.fragment,e),Fo=u(e),Zt=n(e,"P",{});var mp=l(Zt);wr=s(mp,"You can also log in to your Hugging Face account to save and share your trained model on the Hub if you\u2019d like:"),mp.forEach(a),Ho=u(e),m(Ge.$$.fragment,e),Wo=u(e),he=n(e,"H2",{class:!0});var Vs=l(he);we=n(Vs,"A",{id:!0,class:!0,href:!0});var _p=l(we);qa=n(_p,"SPAN",{});var gp=l(qa);m(Ke.$$.fragment,gp),gp.forEach(a),_p.forEach(a),kr=u(Vs),ja=n(Vs,"SPAN",{});var vp=l(ja);$r=s(vp,"Load dataset and metric"),vp.forEach(a),Vs.forEach(a),Uo=u(e),Q=n(e,"P",{});var ha=l(Q);Er=s(ha,"The "),Xe=n(ha,"A",{href:!0,rel:!0});var bp=l(Xe);qr=s(bp,"Common Voice 11.0"),bp.forEach(a),jr=s(ha," dataset contains many hours of recorded speech in many different languages. This guide uses the "),Ze=n(ha,"A",{href:!0,rel:!0});var yp=l(Ze);Sr=s(yp,"Marathi"),yp.forEach(a),Ar=s(ha," language as an example, but feel free to use any other language you\u2019re interested in."),ha.forEach(a),Vo=u(e),C=n(e,"P",{});var B=l(C);Cr=s(B,"Initialize a "),Qe=n(B,"A",{href:!0,rel:!0});var wp=l(Qe);Pr=s(wp,"DatasetDict"),wp.forEach(a),Dr=s(B," structure, and load the "),Sa=n(B,"CODE",{});var kp=l(Sa);Tr=s(kp,"train"),kp.forEach(a),Lr=s(B," (load both the "),Aa=n(B,"CODE",{});var $p=l(Aa);zr=s($p,"train+validation"),$p.forEach(a),xr=s(B," split into "),Ca=n(B,"CODE",{});var Ep=l(Ca);Or=s(Ep,"train"),Ep.forEach(a),Ir=s(B,") and "),Pa=n(B,"CODE",{});var qp=l(Pa);Rr=s(qp,"test"),qp.forEach(a),Mr=s(B," splits from the dataset into it:"),B.forEach(a),Yo=u(e),m(Je.$$.fragment,e),Bo=u(e),fe=n(e,"H2",{class:!0});var Ys=l(fe);ke=n(Ys,"A",{id:!0,class:!0,href:!0});var jp=l(ke);Da=n(jp,"SPAN",{});var Sp=l(Da);m(et.$$.fragment,Sp),Sp.forEach(a),jp.forEach(a),Nr=u(Ys),Ta=n(Ys,"SPAN",{});var Ap=l(Ta);Fr=s(Ap,"Preprocess dataset"),Ap.forEach(a),Ys.forEach(a),Go=u(e),Qt=n(e,"P",{});var Cp=l(Qt);Hr=s(Cp,"Let\u2019s prepare the dataset for training. Load a feature extractor, tokenizer, and processor. You should also pass the language and task to the tokenizer and processor so they know how to process the inputs:"),Cp.forEach(a),Ko=u(e),m(tt.$$.fragment,e),Xo=u(e),W=n(e,"P",{});var ze=l(W);Wr=s(ze,"You\u2019ll only be training on the "),La=n(ze,"CODE",{});var Pp=l(La);Ur=s(Pp,"sentence"),Pp.forEach(a),Vr=s(ze," and "),za=n(ze,"CODE",{});var Dp=l(za);Yr=s(Dp,"audio"),Dp.forEach(a),Br=s(ze," columns, so you can remove the rest of the metadata with "),at=n(ze,"A",{href:!0,rel:!0});var Tp=l(at);Gr=s(Tp,"remove_columns"),Tp.forEach(a),Kr=s(ze,":"),ze.forEach(a),Zo=u(e),m(ot.$$.fragment,e),Qo=u(e),T=n(e,"P",{});var se=l(T);Xr=s(se,"If you look at the "),xa=n(se,"CODE",{});var Lp=l(xa);Zr=s(Lp,"sampling_rate"),Lp.forEach(a),Qr=s(se,", you\u2019ll see the audio was sampled at 48kHz. The Whisper model was pretrained on audio inputs at 16kHZ which means you\u2019ll need to downsample the audio inputs to match what the model was pretrained on. Downsample the audio by using the "),st=n(se,"A",{href:!0,rel:!0});var zp=l(st);Jr=s(zp,"cast_column"),zp.forEach(a),en=s(se," method on the "),Oa=n(se,"CODE",{});var xp=l(Oa);tn=s(xp,"audio"),xp.forEach(a),an=s(se," column, and set the "),Ia=n(se,"CODE",{});var Op=l(Ia);on=s(Op,"sampling_rate"),Op.forEach(a),sn=s(se," to 16kHz. The audio input is resampled on the fly the next time you call it:"),se.forEach(a),Jo=u(e),m(rt.$$.fragment,e),es=u(e),Jt=n(e,"P",{});var Ip=l(Jt);rn=s(Ip,"Once you\u2019ve cleaned up the dataset, you can write a function to generate the correct model inputs. The function should:"),Ip.forEach(a),ts=u(e),J=n(e,"OL",{});var fa=l(J);nt=n(fa,"LI",{});var Bs=l(nt);nn=s(Bs,"Resample the audio inputs to 16kHZ by loading the "),Ra=n(Bs,"CODE",{});var Rp=l(Ra);ln=s(Rp,"audio"),Rp.forEach(a),pn=s(Bs," column."),Bs.forEach(a),cn=u(fa),lt=n(fa,"LI",{});var Gs=l(lt);dn=s(Gs,"Compute the input features from the audio "),Ma=n(Gs,"CODE",{});var Mp=l(Ma);un=s(Mp,"array"),Mp.forEach(a),hn=s(Gs," using the feature extractor."),Gs.forEach(a),fn=u(fa),it=n(fa,"LI",{});var Ks=l(it);mn=s(Ks,"Tokenize the "),Na=n(Ks,"CODE",{});var Np=l(Na);_n=s(Np,"sentence"),Np.forEach(a),gn=s(Ks," column to the input labels."),Ks.forEach(a),fa.forEach(a),as=u(e),m(pt.$$.fragment,e),os=u(e),q=n(e,"P",{});var O=l(q);vn=s(O,"Apply the "),Fa=n(O,"CODE",{});var Fp=l(Fa);bn=s(Fp,"prepare_dataset"),Fp.forEach(a),yn=s(O," function to the dataset with the "),ct=n(O,"A",{href:!0,rel:!0});var Hp=l(ct);wn=s(Hp,"map"),Hp.forEach(a),kn=s(O," function, and set the "),Ha=n(O,"CODE",{});var Wp=l(Ha);$n=s(Wp,"num_proc"),Wp.forEach(a),En=s(O," argument to "),Wa=n(O,"CODE",{});var Up=l(Wa);qn=s(Up,"2"),Up.forEach(a),jn=s(O," to enable multiprocessing (if "),Ua=n(O,"CODE",{});var Vp=l(Ua);Sn=s(Vp,"map"),Vp.forEach(a),An=s(O," hangs, then set "),Va=n(O,"CODE",{});var Yp=l(Va);Cn=s(Yp,"num_proc=1"),Yp.forEach(a),Pn=s(O,"):"),O.forEach(a),ss=u(e),m(dt.$$.fragment,e),rs=u(e),ee=n(e,"P",{});var ma=l(ee);Dn=s(ma,"Finally, create a "),Ya=n(ma,"CODE",{});var Bp=l(Ya);Tn=s(Bp,"DataCollator"),Bp.forEach(a),Ln=s(ma," class to pad the labels in each batch to the maximum length, and replace padding with "),Ba=n(ma,"CODE",{});var Gp=l(Ba);zn=s(Gp,"-100"),Gp.forEach(a),xn=s(ma," so they\u2019re ignored by the loss function. Then initialize an instance of the data collator:"),ma.forEach(a),ns=u(e),m(ut.$$.fragment,e),ls=u(e),me=n(e,"H2",{class:!0});var Xs=l(me);$e=n(Xs,"A",{id:!0,class:!0,href:!0});var Kp=l($e);Ga=n(Kp,"SPAN",{});var Xp=l(Ga);m(ht.$$.fragment,Xp),Xp.forEach(a),Kp.forEach(a),On=u(Xs),Ka=n(Xs,"SPAN",{});var Zp=l(Ka);In=s(Zp,"Train"),Zp.forEach(a),Xs.forEach(a),is=u(e),j=n(e,"P",{});var I=l(j);Rn=s(I,"Now that the dataset is ready, you can turn your attention to the model. Start by loading the pretrained "),ea=n(I,"A",{href:!0});var Qp=l(ea);Xa=n(Qp,"CODE",{});var Jp=l(Xa);Mn=s(Jp,"openai/whisper-large-v2"),Jp.forEach(a),Qp.forEach(a),Nn=s(I," model from "),ft=n(I,"A",{href:!0,rel:!0});var ec=l(ft);Fn=s(ec,"AutoModelForSpeechSeq2Seq"),ec.forEach(a),Hn=s(I,", and make sure to set the "),Za=n(I,"CODE",{});var tc=l(Za);Wn=s(tc,"load_in_8bit"),tc.forEach(a),Un=s(I," argument to "),Qa=n(I,"CODE",{});var ac=l(Qa);Vn=s(ac,"True"),ac.forEach(a),Yn=s(I," to enable "),Ja=n(I,"CODE",{});var oc=l(Ja);Bn=s(oc,"int8"),oc.forEach(a),Gn=s(I," quantization. The "),eo=n(I,"CODE",{});var sc=l(eo);Kn=s(sc,"device_map=auto"),sc.forEach(a),Xn=s(I," argument automatically determines how to load and store the model weights:"),I.forEach(a),ps=u(e),m(mt.$$.fragment,e),cs=u(e),Ee=n(e,"P",{});var Zs=l(Ee);Zn=s(Zs,"You should configure "),to=n(Zs,"CODE",{});var rc=l(to);Qn=s(rc,"forced_decoder_ids=None"),rc.forEach(a),Jn=s(Zs," because no tokens are used before sampling, and you won\u2019t need to suppress any tokens during generation either:"),Zs.forEach(a),ds=u(e),m(_t.$$.fragment,e),us=u(e),te=n(e,"P",{});var _a=l(te);el=s(_a,"To get the model ready for "),ao=n(_a,"CODE",{});var nc=l(ao);tl=s(nc,"int8"),nc.forEach(a),al=s(_a," quantization, use the utility function "),gt=n(_a,"A",{href:!0,rel:!0});var lc=l(gt);oo=n(lc,"CODE",{});var ic=l(oo);ol=s(ic,"prepare_model_for_int8_training"),ic.forEach(a),lc.forEach(a),sl=s(_a," to handle the following:"),_a.forEach(a),hs=u(e),U=n(e,"UL",{});var xe=l(U);_e=n(xe,"LI",{});var ga=l(_e);rl=s(ga,"casts the "),so=n(ga,"CODE",{});var pc=l(so);nl=s(pc,"LayerNorm"),pc.forEach(a),ll=s(ga," to full precision ("),ro=n(ga,"CODE",{});var cc=l(ro);il=s(cc,"fp32"),cc.forEach(a),pl=s(ga,") for stability"),ga.forEach(a),cl=u(xe),no=n(xe,"LI",{});var dc=l(no);dl=s(dc,"adds a forward hook to the input embedding layer to calculate the gradients of the input hidden states"),dc.forEach(a),ul=u(xe),lo=n(xe,"LI",{});var uc=l(lo);hl=s(uc,"enables gradient checkpointing for more memory-efficient training"),uc.forEach(a),fl=u(xe),vt=n(xe,"LI",{});var Qs=l(vt);ml=s(Qs,"casts the output logits to "),io=n(Qs,"CODE",{});var hc=l(io);_l=s(hc,"fp32"),hc.forEach(a),gl=s(Qs," for smoother sampling"),Qs.forEach(a),xe.forEach(a),fs=u(e),m(bt.$$.fragment,e),ms=u(e),qe=n(e,"P",{});var Js=l(qe);vl=s(Js,"Let\u2019s also apply LoRA to the training to make it even more efficient. Load a "),ta=n(Js,"A",{href:!0});var fc=l(ta);bl=s(fc,"LoraConfig"),fc.forEach(a),yl=s(Js," and configure the following parameters:"),Js.forEach(a),_s=u(e),L=n(e,"UL",{});var re=l(L);aa=n(re,"LI",{});var Xi=l(aa);po=n(Xi,"CODE",{});var mc=l(po);wl=s(mc,"r"),mc.forEach(a),kl=s(Xi,", the dimension of the low-rank matrices"),Xi.forEach(a),$l=u(re),oa=n(re,"LI",{});var Zi=l(oa);co=n(Zi,"CODE",{});var _c=l(co);El=s(_c,"lora_alpha"),_c.forEach(a),ql=s(Zi,", scaling factor for the weight matrices"),Zi.forEach(a),jl=u(re),ae=n(re,"LI",{});var Yt=l(ae);uo=n(Yt,"CODE",{});var gc=l(uo);Sl=s(gc,"target_modules"),gc.forEach(a),Al=s(Yt,", the name of the attention matrices to apply LoRA to ("),ho=n(Yt,"CODE",{});var vc=l(ho);Cl=s(vc,"q_proj"),vc.forEach(a),Pl=s(Yt," and "),fo=n(Yt,"CODE",{});var bc=l(fo);Dl=s(bc,"v_proj"),bc.forEach(a),Tl=s(Yt,", or query and value in this case)"),Yt.forEach(a),Ll=u(re),sa=n(re,"LI",{});var Qi=l(sa);mo=n(Qi,"CODE",{});var yc=l(mo);zl=s(yc,"lora_dropout"),yc.forEach(a),xl=s(Qi,", dropout probability of the LoRA layers"),Qi.forEach(a),Ol=u(re),yt=n(re,"LI",{});var er=l(yt);_o=n(er,"CODE",{});var wc=l(_o);Il=s(wc,"bias"),wc.forEach(a),Rl=s(er,", set to "),go=n(er,"CODE",{});var kc=l(go);Ml=s(kc,"none"),kc.forEach(a),er.forEach(a),re.forEach(a),gs=u(e),m(je.$$.fragment,e),vs=u(e),m(wt.$$.fragment,e),bs=u(e),V=n(e,"P",{});var Oe=l(V);Nl=s(Oe,"After you set up the "),ra=n(Oe,"A",{href:!0});var $c=l(ra);Fl=s($c,"LoraConfig"),$c.forEach(a),Hl=s(Oe,", wrap it and the base model with the "),vo=n(Oe,"CODE",{});var Ec=l(vo);Wl=s(Ec,"get_peft_model()"),Ec.forEach(a),Ul=s(Oe," function to create a "),na=n(Oe,"A",{href:!0});var qc=l(na);Vl=s(qc,"PeftModel"),qc.forEach(a),Yl=s(Oe,". Print out the number of trainable parameters to see how much more efficient LoRA is compared to fully training the model!"),Oe.forEach(a),ys=u(e),m(kt.$$.fragment,e),ws=u(e),z=n(e,"P",{});var ne=l(z);Bl=s(ne,"Now you\u2019re ready to define some training hyperparameters in the "),$t=n(ne,"A",{href:!0,rel:!0});var jc=l($t);Gl=s(jc,"Seq2SeqTrainingArguments"),jc.forEach(a),Kl=s(ne," class, such as where to save the model to, batch size, learning rate, and number of epochs to train for. The "),la=n(ne,"A",{href:!0});var Sc=l(la);Xl=s(Sc,"PeftModel"),Sc.forEach(a),Zl=s(ne," doesn\u2019t have the same signature as the base model, so you\u2019ll need to explicitly set "),bo=n(ne,"CODE",{});var Ac=l(bo);Ql=s(Ac,"remove_unused_columns=False"),Ac.forEach(a),Jl=s(ne," and "),yo=n(ne,"CODE",{});var Cc=l(yo);ei=s(Cc,'label_names=["labels"]'),Cc.forEach(a),ti=s(ne,"."),ne.forEach(a),ks=u(e),m(Et.$$.fragment,e),$s=u(e),Se=n(e,"P",{});var tr=l(Se);ai=s(tr,"It is also a good idea to write a custom "),qt=n(tr,"A",{href:!0,rel:!0});var Pc=l(qt);oi=s(Pc,"TrainerCallback"),Pc.forEach(a),si=s(tr," to save model checkpoints during training:"),tr.forEach(a),Es=u(e),m(jt.$$.fragment,e),qs=u(e),x=n(e,"P",{});var le=l(x);ri=s(le,"Pass the "),wo=n(le,"CODE",{});var Dc=l(wo);ni=s(Dc,"Seq2SeqTrainingArguments"),Dc.forEach(a),li=s(le,", model, datasets, data collator, tokenizer, and callback to the "),St=n(le,"A",{href:!0,rel:!0});var Tc=l(St);ii=s(Tc,"Seq2SeqTrainer"),Tc.forEach(a),pi=s(le,". You can optionally set "),ko=n(le,"CODE",{});var Lc=l(ko);ci=s(Lc,"model.config.use_cache = False"),Lc.forEach(a),di=s(le," to silence any warnings. Once everything is ready, call "),At=n(le,"A",{href:!0,rel:!0});var zc=l(At);ui=s(zc,"train"),zc.forEach(a),hi=s(le," to start training!"),le.forEach(a),js=u(e),m(Ct.$$.fragment,e),Ss=u(e),ge=n(e,"H2",{class:!0});var ar=l(ge);Ae=n(ar,"A",{id:!0,class:!0,href:!0});var xc=l(Ae);$o=n(xc,"SPAN",{});var Oc=l($o);m(Pt.$$.fragment,Oc),Oc.forEach(a),xc.forEach(a),fi=u(ar),Eo=n(ar,"SPAN",{});var Ic=l(Eo);mi=s(Ic,"Evaluate"),Ic.forEach(a),ar.forEach(a),As=u(e),Dt=n(e,"P",{});var Ji=l(Dt);Tt=n(Ji,"A",{href:!0,rel:!0});var Rc=l(Tt);_i=s(Rc,"Word error rate"),Rc.forEach(a),gi=s(Ji," (WER) is a common metric for evaluating ASR models. Load the WER metric from \u{1F917} Evaluate:"),Ji.forEach(a),Cs=u(e),m(Lt.$$.fragment,e),Ps=u(e),Y=n(e,"P",{});var Ie=l(Y);vi=s(Ie,"Write a loop to evaluate the model performance. Set the model to evaluation mode first, and write the loop with "),zt=n(Ie,"A",{href:!0,rel:!0});var Mc=l(zt);qo=n(Mc,"CODE",{});var Nc=l(qo);bi=s(Nc,"torch.cuda.amp.autocast()"),Nc.forEach(a),Mc.forEach(a),yi=s(Ie," because "),jo=n(Ie,"CODE",{});var Fc=l(jo);wi=s(Fc,"int8"),Fc.forEach(a),ki=s(Ie," training requires autocasting. Then, pass a batch of examples to the model to evaluate. Get the decoded predictions and labels, and add them as a batch to the WER metric before calling "),So=n(Ie,"CODE",{});var Hc=l(So);$i=s(Hc,"compute"),Hc.forEach(a),Ei=s(Ie," to get the final WER score:"),Ie.forEach(a),Ds=u(e),m(xt.$$.fragment,e),Ts=u(e),ve=n(e,"H2",{class:!0});var or=l(ve);Ce=n(or,"A",{id:!0,class:!0,href:!0});var Wc=l(Ce);Ao=n(Wc,"SPAN",{});var Uc=l(Ao);m(Ot.$$.fragment,Uc),Uc.forEach(a),Wc.forEach(a),qi=u(or),Co=n(or,"SPAN",{});var Vc=l(Co);ji=s(Vc,"Share model"),Vc.forEach(a),or.forEach(a),Ls=u(e),Pe=n(e,"P",{});var sr=l(Pe);Si=s(sr,"Once you\u2019re happy with your results, you can upload your model to the Hub with the "),It=n(sr,"A",{href:!0,rel:!0});var Yc=l(It);Ai=s(Yc,"push_to_hub"),Yc.forEach(a),Ci=s(sr," method:"),sr.forEach(a),zs=u(e),m(Rt.$$.fragment,e),xs=u(e),be=n(e,"H2",{class:!0});var rr=l(be);De=n(rr,"A",{id:!0,class:!0,href:!0});var Bc=l(De);Po=n(Bc,"SPAN",{});var Gc=l(Po);m(Mt.$$.fragment,Gc),Gc.forEach(a),Bc.forEach(a),Pi=u(rr),Do=n(rr,"SPAN",{});var Kc=l(Do);Di=s(Kc,"Inference"),Kc.forEach(a),rr.forEach(a),Os=u(e),ia=n(e,"P",{});var Xc=l(ia);Ti=s(Xc,"Let\u2019s test the model out now!"),Xc.forEach(a),Is=u(e),P=n(e,"P",{});var G=l(P);Li=s(G,"Instantiate the model configuration from "),pa=n(G,"A",{href:!0});var Zc=l(pa);zi=s(Zc,"PeftConfig"),Zc.forEach(a),xi=s(G,", and from here, you can use the configuration to load the base and "),ca=n(G,"A",{href:!0});var Qc=l(ca);Oi=s(Qc,"PeftModel"),Qc.forEach(a),Ii=s(G,", tokenizer, processor, and feature extractor. Remember to define the "),To=n(G,"CODE",{});var Jc=l(To);Ri=s(Jc,"language"),Jc.forEach(a),Mi=s(G," and "),Lo=n(G,"CODE",{});var ed=l(Lo);Ni=s(ed,"task"),ed.forEach(a),Fi=s(G," in the tokenizer, processor, and "),zo=n(G,"CODE",{});var td=l(zo);Hi=s(td,"forced_decoder_ids"),td.forEach(a),Wi=s(G,":"),G.forEach(a),Rs=u(e),m(Nt.$$.fragment,e),Ms=u(e),oe=n(e,"P",{});var va=l(oe);Ui=s(va,"Load an audio sample (you can listen to it in the "),Ft=n(va,"A",{href:!0,rel:!0});var ad=l(Ft);Vi=s(ad,"Dataset Preview"),ad.forEach(a),Yi=s(va,") to transcribe, and the "),Ht=n(va,"A",{href:!0,rel:!0});var od=l(Ht);Bi=s(od,"AutomaticSpeechRecognitionPipeline"),od.forEach(a),Gi=s(va,":"),va.forEach(a),Ns=u(e),m(Wt.$$.fragment,e),Fs=u(e),da=n(e,"P",{});var sd=l(da);Ki=s(sd,"Then use the pipeline with autocast as a context manager on the audio sample:"),sd.forEach(a),Hs=u(e),m(Ut.$$.fragment,e),this.h()},h(){c(h,"name","hf:doc:metadata"),c(h,"content",JSON.stringify(fd)),c(A,"id","int8-training-for-automatic-speech-recognition"),c(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(A,"href","#int8-training-for-automatic-speech-recognition"),c(w,"class","relative group"),c(We,"href","https://huggingface.co/openai/whisper-large-v2"),c(We,"rel","nofollow"),c(Ue,"href","https://huggingface.co/datasets/mozilla-foundation/common_voice_11_0"),c(Ue,"rel","nofollow"),c(ye,"id","setup"),c(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ye,"href","#setup"),c(ue,"class","relative group"),c(we,"id","load-dataset-and-metric"),c(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(we,"href","#load-dataset-and-metric"),c(he,"class","relative group"),c(Xe,"href","https://huggingface.co/datasets/mozilla-foundation/common_voice_11_0"),c(Xe,"rel","nofollow"),c(Ze,"href","https://huggingface.co/datasets/mozilla-foundation/common_voice_11_0/viewer/mr/train"),c(Ze,"rel","nofollow"),c(Qe,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.DatasetDict"),c(Qe,"rel","nofollow"),c(ke,"id","preprocess-dataset"),c(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ke,"href","#preprocess-dataset"),c(fe,"class","relative group"),c(at,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.remove_columns"),c(at,"rel","nofollow"),c(st,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.cast_column"),c(st,"rel","nofollow"),c(ct,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.map"),c(ct,"rel","nofollow"),c($e,"id","train"),c($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c($e,"href","#train"),c(me,"class","relative group"),c(ea,"href",""),c(ft,"href","https://huggingface.co/docs/transformers/main/en/model_doc/auto#transformers.AutoModelForSpeechSeq2Seq"),c(ft,"rel","nofollow"),c(gt,"href","https://github.com/huggingface/peft/blob/34027fe813756897767b9a6f19ae7f1c4c7b418c/src/peft/utils/other.py#L35"),c(gt,"rel","nofollow"),c(ta,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraConfig"),c(ra,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraConfig"),c(na,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),c($t,"href","https://huggingface.co/docs/transformers/main/en/main_classes/trainer#transformers.Seq2SeqTrainingArguments"),c($t,"rel","nofollow"),c(la,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),c(qt,"href","https://huggingface.co/docs/transformers/main/en/main_classes/callback#transformers.TrainerCallback"),c(qt,"rel","nofollow"),c(St,"href","https://huggingface.co/docs/transformers/main/en/main_classes/trainer#transformers.Seq2SeqTrainer"),c(St,"rel","nofollow"),c(At,"href","https://huggingface.co/docs/transformers/main/en/main_classes/trainer#transformers.Trainer.train"),c(At,"rel","nofollow"),c(Ae,"id","evaluate"),c(Ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ae,"href","#evaluate"),c(ge,"class","relative group"),c(Tt,"href","https://huggingface.co/spaces/evaluate-metric/wer"),c(Tt,"rel","nofollow"),c(zt,"href","https://pytorch.org/docs/stable/amp.html"),c(zt,"rel","nofollow"),c(Ce,"id","share-model"),c(Ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ce,"href","#share-model"),c(ve,"class","relative group"),c(It,"href","https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.push_to_hub"),c(It,"rel","nofollow"),c(De,"id","inference"),c(De,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(De,"href","#inference"),c(be,"class","relative group"),c(pa,"href","/docs/peft/main/en/package_reference/config#peft.PeftConfig"),c(ca,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),c(Ft,"href","https://huggingface.co/datasets/stevhliu/dummy"),c(Ft,"rel","nofollow"),c(Ht,"href","https://huggingface.co/docs/transformers/main/en/main_classes/pipelines#transformers.AutomaticSpeechRecognitionPipeline"),c(Ht,"rel","nofollow")},m(e,i){t(document.head,h),p(e,N,i),p(e,w,i),t(w,A),t(A,R),_(k,R,null),t(w,K),t(w,M),t(M,D),p(e,S,i),p(e,E,i),t(E,F),t(E,ie),t(ie,Me),t(E,pe),t(E,ce),t(ce,Ne),t(E,de),t(E,$),t($,Gt),t(E,Kt),p(e,Fe,i),_(X,e,i),p(e,He,i),p(e,H,i),t(H,nr),t(H,We),t(We,ba),t(ba,lr),t(H,ir),t(H,ya),t(ya,pr),t(H,cr),t(H,Ue),t(Ue,dr),t(H,ur),p(e,Oo,i),p(e,Xt,i),t(Xt,hr),p(e,Io,i),_(Ve,e,i),p(e,Ro,i),p(e,ue,i),t(ue,ye),t(ye,wa),_(Ye,wa,null),t(ue,fr),t(ue,ka),t(ka,mr),p(e,Mo,i),p(e,Z,i),t(Z,_r),t(Z,$a),t($a,gr),t(Z,vr),t(Z,Ea),t(Ea,br),t(Z,yr),p(e,No,i),_(Be,e,i),p(e,Fo,i),p(e,Zt,i),t(Zt,wr),p(e,Ho,i),_(Ge,e,i),p(e,Wo,i),p(e,he,i),t(he,we),t(we,qa),_(Ke,qa,null),t(he,kr),t(he,ja),t(ja,$r),p(e,Uo,i),p(e,Q,i),t(Q,Er),t(Q,Xe),t(Xe,qr),t(Q,jr),t(Q,Ze),t(Ze,Sr),t(Q,Ar),p(e,Vo,i),p(e,C,i),t(C,Cr),t(C,Qe),t(Qe,Pr),t(C,Dr),t(C,Sa),t(Sa,Tr),t(C,Lr),t(C,Aa),t(Aa,zr),t(C,xr),t(C,Ca),t(Ca,Or),t(C,Ir),t(C,Pa),t(Pa,Rr),t(C,Mr),p(e,Yo,i),_(Je,e,i),p(e,Bo,i),p(e,fe,i),t(fe,ke),t(ke,Da),_(et,Da,null),t(fe,Nr),t(fe,Ta),t(Ta,Fr),p(e,Go,i),p(e,Qt,i),t(Qt,Hr),p(e,Ko,i),_(tt,e,i),p(e,Xo,i),p(e,W,i),t(W,Wr),t(W,La),t(La,Ur),t(W,Vr),t(W,za),t(za,Yr),t(W,Br),t(W,at),t(at,Gr),t(W,Kr),p(e,Zo,i),_(ot,e,i),p(e,Qo,i),p(e,T,i),t(T,Xr),t(T,xa),t(xa,Zr),t(T,Qr),t(T,st),t(st,Jr),t(T,en),t(T,Oa),t(Oa,tn),t(T,an),t(T,Ia),t(Ia,on),t(T,sn),p(e,Jo,i),_(rt,e,i),p(e,es,i),p(e,Jt,i),t(Jt,rn),p(e,ts,i),p(e,J,i),t(J,nt),t(nt,nn),t(nt,Ra),t(Ra,ln),t(nt,pn),t(J,cn),t(J,lt),t(lt,dn),t(lt,Ma),t(Ma,un),t(lt,hn),t(J,fn),t(J,it),t(it,mn),t(it,Na),t(Na,_n),t(it,gn),p(e,as,i),_(pt,e,i),p(e,os,i),p(e,q,i),t(q,vn),t(q,Fa),t(Fa,bn),t(q,yn),t(q,ct),t(ct,wn),t(q,kn),t(q,Ha),t(Ha,$n),t(q,En),t(q,Wa),t(Wa,qn),t(q,jn),t(q,Ua),t(Ua,Sn),t(q,An),t(q,Va),t(Va,Cn),t(q,Pn),p(e,ss,i),_(dt,e,i),p(e,rs,i),p(e,ee,i),t(ee,Dn),t(ee,Ya),t(Ya,Tn),t(ee,Ln),t(ee,Ba),t(Ba,zn),t(ee,xn),p(e,ns,i),_(ut,e,i),p(e,ls,i),p(e,me,i),t(me,$e),t($e,Ga),_(ht,Ga,null),t(me,On),t(me,Ka),t(Ka,In),p(e,is,i),p(e,j,i),t(j,Rn),t(j,ea),t(ea,Xa),t(Xa,Mn),t(j,Nn),t(j,ft),t(ft,Fn),t(j,Hn),t(j,Za),t(Za,Wn),t(j,Un),t(j,Qa),t(Qa,Vn),t(j,Yn),t(j,Ja),t(Ja,Bn),t(j,Gn),t(j,eo),t(eo,Kn),t(j,Xn),p(e,ps,i),_(mt,e,i),p(e,cs,i),p(e,Ee,i),t(Ee,Zn),t(Ee,to),t(to,Qn),t(Ee,Jn),p(e,ds,i),_(_t,e,i),p(e,us,i),p(e,te,i),t(te,el),t(te,ao),t(ao,tl),t(te,al),t(te,gt),t(gt,oo),t(oo,ol),t(te,sl),p(e,hs,i),p(e,U,i),t(U,_e),t(_e,rl),t(_e,so),t(so,nl),t(_e,ll),t(_e,ro),t(ro,il),t(_e,pl),t(U,cl),t(U,no),t(no,dl),t(U,ul),t(U,lo),t(lo,hl),t(U,fl),t(U,vt),t(vt,ml),t(vt,io),t(io,_l),t(vt,gl),p(e,fs,i),_(bt,e,i),p(e,ms,i),p(e,qe,i),t(qe,vl),t(qe,ta),t(ta,bl),t(qe,yl),p(e,_s,i),p(e,L,i),t(L,aa),t(aa,po),t(po,wl),t(aa,kl),t(L,$l),t(L,oa),t(oa,co),t(co,El),t(oa,ql),t(L,jl),t(L,ae),t(ae,uo),t(uo,Sl),t(ae,Al),t(ae,ho),t(ho,Cl),t(ae,Pl),t(ae,fo),t(fo,Dl),t(ae,Tl),t(L,Ll),t(L,sa),t(sa,mo),t(mo,zl),t(sa,xl),t(L,Ol),t(L,yt),t(yt,_o),t(_o,Il),t(yt,Rl),t(yt,go),t(go,Ml),p(e,gs,i),_(je,e,i),p(e,vs,i),_(wt,e,i),p(e,bs,i),p(e,V,i),t(V,Nl),t(V,ra),t(ra,Fl),t(V,Hl),t(V,vo),t(vo,Wl),t(V,Ul),t(V,na),t(na,Vl),t(V,Yl),p(e,ys,i),_(kt,e,i),p(e,ws,i),p(e,z,i),t(z,Bl),t(z,$t),t($t,Gl),t(z,Kl),t(z,la),t(la,Xl),t(z,Zl),t(z,bo),t(bo,Ql),t(z,Jl),t(z,yo),t(yo,ei),t(z,ti),p(e,ks,i),_(Et,e,i),p(e,$s,i),p(e,Se,i),t(Se,ai),t(Se,qt),t(qt,oi),t(Se,si),p(e,Es,i),_(jt,e,i),p(e,qs,i),p(e,x,i),t(x,ri),t(x,wo),t(wo,ni),t(x,li),t(x,St),t(St,ii),t(x,pi),t(x,ko),t(ko,ci),t(x,di),t(x,At),t(At,ui),t(x,hi),p(e,js,i),_(Ct,e,i),p(e,Ss,i),p(e,ge,i),t(ge,Ae),t(Ae,$o),_(Pt,$o,null),t(ge,fi),t(ge,Eo),t(Eo,mi),p(e,As,i),p(e,Dt,i),t(Dt,Tt),t(Tt,_i),t(Dt,gi),p(e,Cs,i),_(Lt,e,i),p(e,Ps,i),p(e,Y,i),t(Y,vi),t(Y,zt),t(zt,qo),t(qo,bi),t(Y,yi),t(Y,jo),t(jo,wi),t(Y,ki),t(Y,So),t(So,$i),t(Y,Ei),p(e,Ds,i),_(xt,e,i),p(e,Ts,i),p(e,ve,i),t(ve,Ce),t(Ce,Ao),_(Ot,Ao,null),t(ve,qi),t(ve,Co),t(Co,ji),p(e,Ls,i),p(e,Pe,i),t(Pe,Si),t(Pe,It),t(It,Ai),t(Pe,Ci),p(e,zs,i),_(Rt,e,i),p(e,xs,i),p(e,be,i),t(be,De),t(De,Po),_(Mt,Po,null),t(be,Pi),t(be,Do),t(Do,Di),p(e,Os,i),p(e,ia,i),t(ia,Ti),p(e,Is,i),p(e,P,i),t(P,Li),t(P,pa),t(pa,zi),t(P,xi),t(P,ca),t(ca,Oi),t(P,Ii),t(P,To),t(To,Ri),t(P,Mi),t(P,Lo),t(Lo,Ni),t(P,Fi),t(P,zo),t(zo,Hi),t(P,Wi),p(e,Rs,i),_(Nt,e,i),p(e,Ms,i),p(e,oe,i),t(oe,Ui),t(oe,Ft),t(Ft,Vi),t(oe,Yi),t(oe,Ht),t(Ht,Bi),t(oe,Gi),p(e,Ns,i),_(Wt,e,i),p(e,Fs,i),p(e,da,i),t(da,Ki),p(e,Hs,i),_(Ut,e,i),Ws=!0},p(e,[i]){const Vt={};i&2&&(Vt.$$scope={dirty:i,ctx:e}),X.$set(Vt);const xo={};i&2&&(xo.$$scope={dirty:i,ctx:e}),je.$set(xo)},i(e){Ws||(g(k.$$.fragment,e),g(X.$$.fragment,e),g(Ve.$$.fragment,e),g(Ye.$$.fragment,e),g(Be.$$.fragment,e),g(Ge.$$.fragment,e),g(Ke.$$.fragment,e),g(Je.$$.fragment,e),g(et.$$.fragment,e),g(tt.$$.fragment,e),g(ot.$$.fragment,e),g(rt.$$.fragment,e),g(pt.$$.fragment,e),g(dt.$$.fragment,e),g(ut.$$.fragment,e),g(ht.$$.fragment,e),g(mt.$$.fragment,e),g(_t.$$.fragment,e),g(bt.$$.fragment,e),g(je.$$.fragment,e),g(wt.$$.fragment,e),g(kt.$$.fragment,e),g(Et.$$.fragment,e),g(jt.$$.fragment,e),g(Ct.$$.fragment,e),g(Pt.$$.fragment,e),g(Lt.$$.fragment,e),g(xt.$$.fragment,e),g(Ot.$$.fragment,e),g(Rt.$$.fragment,e),g(Mt.$$.fragment,e),g(Nt.$$.fragment,e),g(Wt.$$.fragment,e),g(Ut.$$.fragment,e),Ws=!0)},o(e){v(k.$$.fragment,e),v(X.$$.fragment,e),v(Ve.$$.fragment,e),v(Ye.$$.fragment,e),v(Be.$$.fragment,e),v(Ge.$$.fragment,e),v(Ke.$$.fragment,e),v(Je.$$.fragment,e),v(et.$$.fragment,e),v(tt.$$.fragment,e),v(ot.$$.fragment,e),v(rt.$$.fragment,e),v(pt.$$.fragment,e),v(dt.$$.fragment,e),v(ut.$$.fragment,e),v(ht.$$.fragment,e),v(mt.$$.fragment,e),v(_t.$$.fragment,e),v(bt.$$.fragment,e),v(je.$$.fragment,e),v(wt.$$.fragment,e),v(kt.$$.fragment,e),v(Et.$$.fragment,e),v(jt.$$.fragment,e),v(Ct.$$.fragment,e),v(Pt.$$.fragment,e),v(Lt.$$.fragment,e),v(xt.$$.fragment,e),v(Ot.$$.fragment,e),v(Rt.$$.fragment,e),v(Mt.$$.fragment,e),v(Nt.$$.fragment,e),v(Wt.$$.fragment,e),v(Ut.$$.fragment,e),Ws=!1},d(e){a(h),e&&a(N),e&&a(w),b(k),e&&a(S),e&&a(E),e&&a(Fe),b(X,e),e&&a(He),e&&a(H),e&&a(Oo),e&&a(Xt),e&&a(Io),b(Ve,e),e&&a(Ro),e&&a(ue),b(Ye),e&&a(Mo),e&&a(Z),e&&a(No),b(Be,e),e&&a(Fo),e&&a(Zt),e&&a(Ho),b(Ge,e),e&&a(Wo),e&&a(he),b(Ke),e&&a(Uo),e&&a(Q),e&&a(Vo),e&&a(C),e&&a(Yo),b(Je,e),e&&a(Bo),e&&a(fe),b(et),e&&a(Go),e&&a(Qt),e&&a(Ko),b(tt,e),e&&a(Xo),e&&a(W),e&&a(Zo),b(ot,e),e&&a(Qo),e&&a(T),e&&a(Jo),b(rt,e),e&&a(es),e&&a(Jt),e&&a(ts),e&&a(J),e&&a(as),b(pt,e),e&&a(os),e&&a(q),e&&a(ss),b(dt,e),e&&a(rs),e&&a(ee),e&&a(ns),b(ut,e),e&&a(ls),e&&a(me),b(ht),e&&a(is),e&&a(j),e&&a(ps),b(mt,e),e&&a(cs),e&&a(Ee),e&&a(ds),b(_t,e),e&&a(us),e&&a(te),e&&a(hs),e&&a(U),e&&a(fs),b(bt,e),e&&a(ms),e&&a(qe),e&&a(_s),e&&a(L),e&&a(gs),b(je,e),e&&a(vs),b(wt,e),e&&a(bs),e&&a(V),e&&a(ys),b(kt,e),e&&a(ws),e&&a(z),e&&a(ks),b(Et,e),e&&a($s),e&&a(Se),e&&a(Es),b(jt,e),e&&a(qs),e&&a(x),e&&a(js),b(Ct,e),e&&a(Ss),e&&a(ge),b(Pt),e&&a(As),e&&a(Dt),e&&a(Cs),b(Lt,e),e&&a(Ps),e&&a(Y),e&&a(Ds),b(xt,e),e&&a(Ts),e&&a(ve),b(Ot),e&&a(Ls),e&&a(Pe),e&&a(zs),b(Rt,e),e&&a(xs),e&&a(be),b(Mt),e&&a(Os),e&&a(ia),e&&a(Is),e&&a(P),e&&a(Rs),b(Nt,e),e&&a(Ms),e&&a(oe),e&&a(Ns),b(Wt,e),e&&a(Fs),e&&a(da),e&&a(Hs),b(Ut,e)}}}const fd={local:"int8-training-for-automatic-speech-recognition",sections:[{local:"setup",title:"Setup"},{local:"load-dataset-and-metric",title:"Load dataset and metric"},{local:"preprocess-dataset",title:"Preprocess dataset"},{local:"train",title:"Train"},{local:"evaluate",title:"Evaluate"},{local:"share-model",title:"Share model"},{local:"inference",title:"Inference"}],title:"int8 training for automatic speech recognition"};function md(Bt){return cd(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class yd extends nd{constructor(h){super();ld(this,h,md,hd,id,{})}}export{yd as default,fd as metadata};
